- Main Page
- Modules
- Namespaces
- Classes
- Files
- Directories
- Related Pages

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# RakPeerInterface Class Reference

The main interface for network communications. More...

`#include <RakPeerInterface.h>`

Inheritance diagram for RakPeerInterface:

List of all members.

## Public Member Functions
virtual | ~RakPeerInterface ()
| Destructor.
virtual bool | Initialize (unsigned short maxConnections, unsigned short localPort, int _threadSleepTimer, const char *forceHostAddress=0)=0
| Starts the network threads, opens the listen port. You must call this before calling Connect(). Multiple calls while already active are ignored. To call this function again with different settings, you must first call Disconnect().
virtual void | InitializeSecurity (const char *pubKeyE, const char *pubKeyN, const char *privKeyP, const char *privKeyQ)=0
virtual void | DisableSecurity (void)=0
virtual void | SetMaximumIncomingConnections (unsigned short numberAllowed)=0
virtual unsigned short | GetMaximumIncomingConnections (void) const =0
virtual void | SetIncomingPassword (const char *passwordData, int passwordDataLength)=0
virtual void | GetIncomingPassword (char *passwordData, int *passwordDataLength)=0
virtual bool | Connect (const char *host, unsigned short remotePort, char *passwordData, int passwordDataLength)=0
| Connect to the specified host (ip or domain name) and server port. Calling Connect and not calling SetMaximumIncomingConnections acts as a dedicated client. Calling both acts as a true peer. This is a non-blocking connection. You know the connection is successful when IsConnected() returns true or Receive() gets a message with the type identifier ID_CONNECTION_ACCEPTED. If the connection is not successful, such as a rejected connection or no response then neither of these things will happen.
virtual void | Disconnect (unsigned int blockDuration, unsigned char orderingChannel=0)=0
| Stops the network threads and closes all connections.
virtual bool | IsActive (void) const =0
virtual bool | GetConnectionList (PlayerID *remoteSystems, unsigned short *numberOfSystems) const =0
virtual bool | Send (const char *data, const int length, PacketPriority priority, PacketReliability reliability, char orderingChannel, PlayerID playerId, bool broadcast)=0
virtual bool | Send (RakNet::BitStream *bitStream, PacketPriority priority, PacketReliability reliability, char orderingChannel, PlayerID playerId, bool broadcast)=0
virtual Packet * | Receive (void)=0
virtual void | DeallocatePacket (Packet *packet)=0
virtual unsigned short | GetMaximumNumberOfPeers (void) const =0
| Return the total number of connections we are allowed.
virtual void | RegisterAsRemoteProcedureCall (char *uniqueID, void(*functionPointer)(RPCParameters *rpcParms))=0
virtual void | RegisterClassMemberRPC (char *uniqueID, void *functionPointer)=0
virtual void | UnregisterAsRemoteProcedureCall (char *uniqueID)=0
virtual bool | RPC (char *uniqueID, const char *data, unsigned int bitLength, PacketPriority priority, PacketReliability reliability, char orderingChannel, PlayerID playerId, bool broadcast, bool shiftTimestamp, NetworkID networkID, RakNet::BitStream *replyFromTarget)=0
virtual bool | RPC (char *uniqueID, RakNet::BitStream *bitStream, PacketPriority priority, PacketReliability reliability, char orderingChannel, PlayerID playerId, bool broadcast, bool shiftTimestamp, NetworkID networkID, RakNet::BitStream *replyFromTarget)=0
virtual void | CloseConnection (const PlayerID target, bool sendDisconnectionNotification, unsigned char orderingChannel=0)=0
virtual int | GetIndexFromPlayerID (const PlayerID playerId)=0
virtual PlayerID | GetPlayerIDFromIndex (int index)=0
virtual void | AddToBanList (const char *IP, RakNetTime milliseconds=0)=0
virtual void | RemoveFromBanList (const char *IP)=0
virtual void | ClearBanList (void)=0
| Allows all previously banned IPs to connect.
virtual bool | IsBanned (const char *IP)=0
virtual void | Ping (const PlayerID target)=0
virtual void | Ping (const char *host, unsigned short remotePort, bool onlyReplyOnAcceptingConnections)=0
virtual int | GetAveragePing (const PlayerID playerId)=0
virtual int | GetLastPing (const PlayerID playerId) const =0
virtual int | GetLowestPing (const PlayerID playerId) const =0
virtual void | SetOccasionalPing (bool doPing)=0
virtual RakNet::BitStream * | GetRemoteStaticData (const PlayerID playerId)=0
virtual void | SetRemoteStaticData (const PlayerID playerId, const char *data, const int length)=0
virtual void | SendStaticData (const PlayerID target)=0
virtual void | SetOfflinePingResponse (const char *data, const unsigned int length)=0
virtual PlayerID | GetInternalID (void) const =0
virtual PlayerID | GetExternalID (const PlayerID target) const =0
virtual void | SetTimeoutTime (RakNetTime timeMS, const PlayerID target)=0
virtual bool | SetMTUSize (int size)=0
virtual int | GetMTUSize (void) const =0
virtual unsigned | GetNumberOfAddresses (void)=0
| Returns the number of IP addresses this system has internally. Get the actual addresses from GetLocalIP().
virtual const char * | GetLocalIP (unsigned int index)=0
| Returns an IP address at index 0 to GetNumberOfAddresses-1.
virtual const char * | PlayerIDToDottedIP (const PlayerID playerId) const =0
virtual void | IPToPlayerID (const char *host, unsigned short remotePort, PlayerID *playerId)=0
virtual void | AllowConnectionResponseIPMigration (bool allow)=0
virtual void | AdvertiseSystem (const char *host, unsigned short remotePort, const char *data, int dataLength)=0
virtual void | SetSplitMessageProgressInterval (int interval)=0
virtual void | SetUnreliableTimeout (RakNetTime timeoutMS)=0
virtual void | SetCompileFrequencyTable (bool doCompile)=0
virtual bool | GetOutgoingFrequencyTable (unsigned int outputFrequencyTable[256])=0
virtual bool | GenerateCompressionLayer (unsigned int inputFrequencyTable[256], bool inputLayer)=0
virtual bool | DeleteCompressionLayer (bool inputLayer)=0
virtual float | GetCompressionRatio (void) const =0
virtual float | GetDecompressionRatio (void) const =0
virtual void | AttachPlugin (PluginInterface *plugin)=0
virtual void | DetachPlugin (PluginInterface *messageHandler)=0
virtual void | PushBackPacket (Packet *packet, bool pushAtHead)=0
virtual void | SetRouterInterface (RouterInterface *routerInterface)=0
| For internal use only.
virtual void | RemoveRouterInterface (RouterInterface *routerInterface)=0
| For internal use only.
virtual void | ApplyNetworkSimulator (double maxSendBPS, unsigned short minExtraPing, unsigned short extraPingVariance)=0
virtual bool | IsNetworkSimulatorActive (void)=0
virtual RakNetStatisticsStruct *const | GetStatistics (const PlayerID playerId)=0
virtual RPCMap * | GetRPCMap (const PlayerID playerId)=0

## Detailed Description

The main interface for network communications.

The primary interface for RakNet, RakPeer contains all major functions for the library. See the individual functions for what the class can do.

## Member Function Documentation

virtual void RakPeerInterface::AddToBanList | ( | const char * | IP,
|  | RakNetTime | milliseconds = `0`
| ) | `[pure virtual]`

  | Bans an IP from connecting. Banned IPs persist between connections but are not saved on shutdown nor loaded on startup. param[in] IP Dotted IP address. Can use * as a wildcard, such as 128.0.0.* will ban all IP addresses starting with 128.0.0 Parameters:
  `[in]` | milliseconds | how many ms for a temporary ban. Use 0 for a permanent ban
Implemented in RakPeer.

virtual void RakPeerInterface::AdvertiseSystem | ( | const char * | host,
|  | unsigned short | remotePort,
|  | const char * | data,
|  | int | dataLength
| ) | `[pure virtual]`

  | Sends a one byte message ID_ADVERTISE_SYSTEM to the remote unconnected system. This will tell the remote system our external IP outside the LAN along with some user data. Precondition: The sender and recipient must already be started via a successful call to Initialize Parameters:
  `[in]` | host | Either a dotted IP address or a domain name
  `[in]` | remotePort | Which port to connect to on the remote machine.
  `[in]` | data | Optional data to append to the packet.
  `[in]` | dataLength | length of data in bytes. Use 0 if no data.
Implemented in RakClient, RakPeer, and RakServer.

virtual void RakPeerInterface::AllowConnectionResponseIPMigration | ( | bool | allow | ) | `[pure virtual]`

  | Allow or disallow connection responses from any IP. Normally this should be false, but may be necessary when connecting to servers with multiple IP addresses. Parameters:
  `[in]` | allow | - True to allow this behavior, false to not allow. Defaults to false. Value persists between connections
Implemented in RakClient, and RakPeer.

virtual void RakPeerInterface::ApplyNetworkSimulator | ( | double | maxSendBPS,
|  | unsigned short | minExtraPing,
|  | unsigned short | extraPingVariance
| ) | `[pure virtual]`

  | Adds simulated ping and packet loss to the outgoing data flow. To simulate bi-directional ping and packet loss, you should call this on both the sender and the recipient, with half the total ping and maxSendBPS value on each. You can exclude network simulator code with the _RELEASE define to decrease code size Parameters:
  `[in]` | maxSendBPS | Maximum bits per second to send. Packetloss grows linearly. 0 to disable.
  `[in]` | minExtraPing | The minimum time to delay sends.
  `[in]` | extraPingVariance | The additional random time to delay sends.
Implemented in RakClient, RakPeer, and RakServer.

virtual void RakPeerInterface::AttachPlugin | ( | PluginInterface * | plugin | ) | `[pure virtual]`

  | Attatches a Plugin interface to run code automatically on message receipt in the Receive call Note: If plugins have dependencies on each other then the order does matter - for example the router plugin should go first because it might route messages for other plugins Parameters:
  `[in]` | messageHandler | Pointer to a plugin to attach
Implemented in RakClient, RakPeer, and RakServer.

virtual void RakPeerInterface::CloseConnection | ( | const PlayerID | target,
|  | bool | sendDisconnectionNotification,
|  | unsigned char | orderingChannel = `0`
| ) | `[pure virtual]`

  | Close the connection to another host (if we initiated the connection it will disconnect, if they did it will kick them out). Parameters:
  `[in]` | target | Which system to close the connection to.
  `[in]` | sendDisconnectionNotification | True to send ID_DISCONNECTION_NOTIFICATION to the recipient. False to close it silently.
  `[in]` | channel | Which ordering channel to send the disconnection notification on, if any
Implemented in RakPeer.

virtual bool RakPeerInterface::Connect | ( | const char * | host,
|  | unsigned short | remotePort,
|  | char * | passwordData,
|  | int | passwordDataLength
| ) | `[pure virtual]`

  | Connect to the specified host (ip or domain name) and server port. Calling Connect and not calling SetMaximumIncomingConnections acts as a dedicated client. Calling both acts as a true peer. This is a non-blocking connection. You know the connection is successful when IsConnected() returns true or Receive() gets a message with the type identifier ID_CONNECTION_ACCEPTED. If the connection is not successful, such as a rejected connection or no response then neither of these things will happen. Precondition: Requires that you first call Initialize Parameters:
  `[in]` | host | Either a dotted IP address or a domain name
  `[in]` | remotePort | Which port to connect to on the remote machine.
  `[in]` | passwordData | A data block that must match the data block on the server passed to SetIncomingPassword. This can be a string or can be a stream of data. Use 0 for no password.
  `[in]` | passwordDataLength | The length in bytes of passwordData
Returns: True on successful initiation. False on incorrect parameters, internal error, or too many existing peers. Returning true does not mean you connected! Implemented in RakPeer.

virtual void RakPeerInterface::DeallocatePacket | ( | Packet * | packet | ) | `[pure virtual]`

  | Call this to deallocate a message returned by Receive() when you are done handling it. Parameters:
  `[in]` | packet | The message to deallocate.
Implemented in RakClient, RakPeer, and RakServer.

virtual bool RakPeerInterface::DeleteCompressionLayer | ( | bool | inputLayer | ) | `[pure virtual]`

  | Delete the output or input layer as specified. This is not necessary to call and is only valuable for freeing memory. Precondition: You should only call this when disconnected Parameters:
  `[in]` | inputLayer | True to mean the inputLayer, false to mean the output layer
Returns: false (failure) if connected. Otherwise true (success) Implemented in RakClient, RakPeer, and RakServer.

virtual void RakPeerInterface::DetachPlugin | ( | PluginInterface * | messageHandler | ) | `[pure virtual]`

  | Detaches a Plugin interface to run code automatically on message receipt Parameters:
  `[in]` | messageHandler | Pointer to a plugin to detach
Implemented in RakClient, RakPeer, and RakServer.

virtual void RakPeerInterface::DisableSecurity | ( | void |  | ) | `[pure virtual]`

| Disables all security. Note: Must be called while offline Implemented in RakPeer, and RakServer.

virtual void RakPeerInterface::Disconnect | ( | unsigned int | blockDuration,
|  | unsigned char | orderingChannel = `0`
| ) | `[pure virtual]`

  | Stops the network threads and closes all connections. Parameters:
  `[in]` | blockDuration | How long you should wait for all remaining messages to go out, including ID_DISCONNECTION_NOTIFICATION. If 0, it doesn't wait at all.
  `[in]` | orderingChannel | If blockDuration > 0, ID_DISCONNECTION_NOTIFICATION will be sent on this channel If you set it to 0 then the disconnection notification won't be sent
Implemented in RakClient, RakPeer, and RakServer.

virtual bool RakPeerInterface::GenerateCompressionLayer | ( | unsigned int | inputFrequencyTable[256],
|  | bool | inputLayer
| ) | `[pure virtual]`

  | This is an optional function to generate the compression layer based on the input frequency table. If you want to use it you should call this twice - once with inputLayer as true and once as false. The frequency table passed here with inputLayer=true should match the frequency table on the recipient with inputLayer=false. Likewise, the frequency table passed here with inputLayer=false should match the frequency table on the recipient with inputLayer=true. Calling this function when there is an existing layer will overwrite the old layer. Precondition: You should only call this when disconnected Parameters:
  `[in]` | inputFrequencyTable | A frequency table for your data
  `[in]` | inputLayer | Is this the input layer?
Returns: false (failure) if connected. Otherwise true (success) See also: Compression.cpp Implemented in RakClient, RakPeer, and RakServer.

virtual int RakPeerInterface::GetAveragePing | ( | const PlayerID | playerId | ) | `[pure virtual]`

  | Returns the average of all ping times read for the specific system or -1 if none read yet Parameters:
  `[in]` | playerId | Which system we are referring to
Returns: The ping time for this system, or -1 Implemented in RakPeer, and RakServer.

virtual float RakPeerInterface::GetCompressionRatio | ( | void |  | ) | const`[pure virtual]`

| Returns the compression ratio. A low compression ratio is good. Compression is for outgoing data Returns: The compression ratio Implemented in RakClient, RakPeer, and RakServer.

virtual bool RakPeerInterface::GetConnectionList | ( | PlayerID * | remoteSystems,
|  | unsigned short * | numberOfSystems
| ) | const`[pure virtual]`

  | Fills the array remoteSystems with the SystemID of all the systems we are connected to Parameters:
  `[out]` | remoteSystems | An array of PlayerID structures to be filled with the PlayerIDs of the systems we are connected to. Pass 0 to remoteSystems to only get the number of systems we are connected to
  `[in,out]` | numberOfSystems | As input, the size of remoteSystems array. As output, the number of elements put into the array
Implemented in RakPeer.

virtual float RakPeerInterface::GetDecompressionRatio | ( | void |  | ) | const`[pure virtual]`

| Returns the decompression ratio. A high decompression ratio is good. Decompression is for incoming data Returns: The decompression ratio Implemented in RakClient, RakPeer, and RakServer.

virtual PlayerID RakPeerInterface::GetExternalID | ( | const PlayerID | target | ) | const`[pure virtual]`

  | Return the unique address identifier that represents you on the the network and is based on your externalIP / port (the IP / port the specified player uses to communicate with you) Parameters:
  `[in]` | target | Which remote system you are referring to for your external ID. Usually the same for all systems, unless you have two or more network cards.
Implemented in RakPeer.

virtual void RakPeerInterface::GetIncomingPassword | ( | char * | passwordData,
|  | int * | passwordDataLength
| ) | `[pure virtual]`

  | Gets the password passed to SetIncomingPassword Parameters:
  `[out]` | passwordData | Should point to a block large enough to hold the password data you passed to SetIncomingPassword()
  `[in,out]` | passwordDataLength | Maximum size of the array passwordData. Modified to hold the number of bytes actually written
Implemented in RakPeer.

virtual int RakPeerInterface::GetIndexFromPlayerID | ( | const PlayerID | playerId | ) | `[pure virtual]`

  | Given a playerID, returns an index from 0 to the maximum number of players allowed - 1. Parameters:
  `[in]` | playerId | The PlayerID we are referring to
Returns: The index of this PlayerID or -1 on system not found. Implemented in RakPeer, and RakServer.

virtual PlayerID RakPeerInterface::GetInternalID | ( | void |  | ) | const`[pure virtual]`

| Return the unique address identifier that represents you on the the network and is based on your local IP / port. Returns: the identifier of your system internally, which may not be how other systems see if you if you are behind a NAT or proxy Implemented in RakClient, RakPeer, and RakServer.

virtual int RakPeerInterface::GetLastPing | ( | const PlayerID | playerId | ) | const`[pure virtual]`

  | Returns the last ping time read for the specific system or -1 if none read yet Parameters:
  `[in]` | playerId | Which system we are referring to
Returns: The last ping time for this system, or -1 Implemented in RakPeer.

virtual int RakPeerInterface::GetLowestPing | ( | const PlayerID | playerId | ) | const`[pure virtual]`

  | Returns the lowest ping time read or -1 if none read yet Parameters:
  `[in]` | playerId | Which system we are referring to
Returns: The lowest ping time for this system, or -1 Implemented in RakPeer.

virtual unsigned short RakPeerInterface::GetMaximumIncomingConnections | ( | void |  | ) | const`[pure virtual]`

| Returns the value passed to SetMaximumIncomingConnections() Returns: the maximum number of incoming connections, which is always <= maxConnections Implemented in RakPeer.

virtual int RakPeerInterface::GetMTUSize | ( | void |  | ) | const`[pure virtual]`

| Returns the current MTU size Returns: The current MTU size Implemented in RakClient, RakPeer, and RakServer.

virtual bool RakPeerInterface::GetOutgoingFrequencyTable | ( | unsigned int | outputFrequencyTable[256] | ) | `[pure virtual]`

  | Returns the frequency of outgoing bytes into output frequency table The purpose is to save to file as either a master frequency table from a sample game session for passing to GenerateCompressionLayer() Precondition: You should only call this when disconnected. Requires that you first enable data frequency tracking by calling SetCompileFrequencyTable(true) Parameters:
  `[out]` | outputFrequencyTable | The frequency of each corresponding byte
Returns: False (failure) if connected or if frequency table tracking is not enabled. Otherwise true (success) Implemented in RakPeer.

virtual PlayerID RakPeerInterface::GetPlayerIDFromIndex | ( | int | index | ) | `[pure virtual]`

  | This function is only useful for looping through all systems Given an index, will return a PlayerID. Parameters:
  `[in]` | index | Index should range between 0 and the maximum number of players allowed - 1.
Returns: The PlayerID Implemented in RakPeer, and RakServer.

virtual RakNet::BitStream* RakPeerInterface::GetRemoteStaticData | ( | const PlayerID | playerId | ) | `[pure virtual]`

  | All systems have a block of data associated with them, for user use. This block of data can be used to easily specify typical system data that you want to know on connection, such as the player's name. Parameters:
  `[in]` | playerId | Which system you are referring to. Pass the value returned by GetInternalID to refer to yourself
Returns: The data passed to SetRemoteStaticData stored as a bitstream Implemented in RakPeer.

virtual RakNetStatisticsStruct* const RakPeerInterface::GetStatistics | ( | const PlayerID | playerId | ) | `[pure virtual]`

  | Returns a structure containing a large set of network statistics for the specified system. You can map this data to a string using the C style StatisticsToString() function Parameters:
  `[in]` | playerId,: | Which connected system to get statistics for
Returns: 0 on can't find the specified system. A pointer to a set of data otherwise. See also: RakNetStatistics.h Implemented in RakPeer, and RakServer.

virtual bool RakPeerInterface::Initialize | ( | unsigned short | maxConnections,
|  | unsigned short | localPort,
|  | int | _threadSleepTimer,
|  | const char * | forceHostAddress = `0`
| ) | `[pure virtual]`

  | Starts the network threads, opens the listen port. You must call this before calling Connect(). Multiple calls while already active are ignored. To call this function again with different settings, you must first call Disconnect(). Note: Call SetMaximumIncomingConnections if you want to accept incoming connections Parameters:
  `[in]` | maxConnections | The maximum number of connections between this instance of RakPeer and another instance of RakPeer. Required so the network can preallocate and for thread safety. A pure client would set this to 1. A pure server would set it to the number of allowed clients.- A hybrid would set it to the sum of both types of connections
  `[in]` | localPort | The port to listen for connections on.
  `[in]` | _threadSleepTimer | How many ms to Sleep each internal update cycle (30 to give the game priority, 0 for regular (recommended), -1 to not Sleep() (may be slower))
  `[in]` | forceHostAddress | Can force RakNet to use a particular IP to host on. Pass 0 to automatically pick an IP
Returns: False on failure (can't create socket or thread), true on success. Implemented in RakPeer.

virtual void RakPeerInterface::InitializeSecurity | ( | const char * | pubKeyE,
|  | const char * | pubKeyN,
|  | const char * | privKeyP,
|  | const char * | privKeyQ
| ) | `[pure virtual]`

  | Secures connections though a combination of SHA1, AES128, SYN Cookies, and RSA to prevent connection spoofing, replay attacks, data eavesdropping, packet tampering, and MitM attacks. There is a significant amount of processing and a slight amount of bandwidth overhead for this feature. If you accept connections, you must call this or else secure connections will not be enabled for incoming connections. If you are connecting to another system, you can call this with values for the (e and p,q) public keys before connecting to prevent MitM Precondition: Must be called while offline Parameters:
  `[in]` | pubKeyE | A pointer to the public keys from the RSACrypt class.
  `[in]` | pubKeyN | A pointer to the public keys from the RSACrypt class.
  `[in]` | privKeyP | Public key generated from the RSACrypt class.
  `[in]` | privKeyQ | Public key generated from the RSACrypt class. If the private keys are 0, then a new key will be generated when this function is called
See also: the Encryption sample Implemented in RakPeer.

virtual void RakPeerInterface::IPToPlayerID | ( | const char * | host,
|  | unsigned short | remotePort,
|  | PlayerID * | playerId
| ) | `[pure virtual]`

  | Converts a dotted IP to a playerId Parameters:
  `[in]` | host | Either a dotted IP address or a domain name
  `[in]` | remotePort | Which port to connect to on the remote machine.
  `[out]` | playerId | The result of this operation
Implemented in RakPeer.

virtual bool RakPeerInterface::IsActive | ( | void |  | ) | const`[pure virtual]`

| Returns if the network thread is running Returns: true if the network thread is running, false otherwise Implemented in RakPeer, and RakServer.

virtual bool RakPeerInterface::IsBanned | ( | const char * | IP | ) | `[pure virtual]`

  | Returns true or false indicating if a particular IP is banned. Parameters:
  `[in]` | IP | - Dotted IP address.
Returns: true if IP matches any IPs in the ban list, accounting for any wildcards. False otherwise. Implemented in RakPeer, and RakServer.

virtual bool RakPeerInterface::IsNetworkSimulatorActive | ( | void |  | ) | `[pure virtual]`

| Returns if you previously called ApplyNetworkSimulator Returns: If you previously called ApplyNetworkSimulator Implemented in RakClient, RakPeer, and RakServer.

virtual void RakPeerInterface::Ping | ( | const char * | host,
|  | unsigned short | remotePort,
|  | bool | onlyReplyOnAcceptingConnections
| ) | `[pure virtual]`

  | Send a ping to the specified unconnected system. The remote system, if it is Initialized, will respond with ID_PONG. The final ping time will be encoded in the following sizeof(RakNetTime) bytes. (Default is 4 bytes - See __GET_TIME_64BIT in NetworkTypes.h Parameters:
  `[in]` | host | Either a dotted IP address or a domain name. Can be 255.255.255.255 for LAN broadcast.
  `[in]` | remotePort | Which port to connect to on the remote machine.
  `[in]` | onlyReplyOnAcceptingConnections | Only request a reply if the remote system is accepting connections
Implemented in RakPeer.

virtual void RakPeerInterface::Ping | ( | const PlayerID | target | ) | `[pure virtual]`

  | Send a ping to the specified connected system. Precondition: The sender and recipient must already be started via a successful call to Initialize() Parameters:
  `[in]` | target | Which system to ping
Implemented in RakPeer.

virtual const char* RakPeerInterface::PlayerIDToDottedIP | ( | const PlayerID | playerId | ) | const`[pure virtual]`

  | TODO - depreciate this Returns the dotted IP address for the specified playerId Parameters:
  `[in]` | playerId | Any player ID other than UNASSIGNED_PLAYER_ID, even if that player is not currently connected
Implemented in RakClient, and RakPeer.

virtual void RakPeerInterface::PushBackPacket | ( | Packet * | packet,
|  | bool | pushAtHead
| ) | `[pure virtual]`

  | Put a message back at the end of the receive queue in case you don't want to deal with it immediately Parameters:
  `[in]` | packet | The packet you want to push back.
  `[in]` | pushAtHead | True to push the packet so that the next receive call returns it. False to push it at the end of the queue (obviously pushing it at the end makes the packets out of order)
Implemented in RakClient, RakPeer, and RakServer.

virtual Packet* RakPeerInterface::Receive | ( | void |  | ) | `[pure virtual]`

| Gets a message from the incoming message queue. Use DeallocatePacket() to deallocate the message after you are done with it. User-thread functions, such as RPC calls and the plugin function PluginInterface::Update occur here. Returns: 0 if no packets are waiting to be handled, otherwise a pointer to a packet. sa NetworkTypes.h contains struct Packet Implemented in RakClient, RakPeer, and RakServer.

virtual void RakPeerInterface::RemoveFromBanList | ( | const char * | IP | ) | `[pure virtual]`

| Allows a previously banned IP to connect. param[in] Dotted IP address. Can use * as a wildcard, such as 128.0.0.* will banAll IP addresses starting with 128.0.0 Implemented in RakPeer, and RakServer.

virtual bool RakPeerInterface::Send | ( | RakNet::BitStream * | bitStream,
|  | PacketPriority | priority,
|  | PacketReliability | reliability,
|  | char | orderingChannel,
|  | PlayerID | playerId,
|  | bool | broadcast
| ) | `[pure virtual]`

  | Sends a block of data to the specified system that you are connected to. Same as the above version, but takes a BitStream as input. Parameters:
  `[in]` | bitStream | The bitstream to send
  `[in]` | priority | What priority level to send on. See PacketPriority.h
  `[in]` | reliability | How reliability to send this data. See PacketPriority.h
  `[in]` | orderingChannel | When using ordered or sequenced messages, what channel to order these on. Messages are only ordered relative to other messages on the same stream
  `[in]` | playerId | Who to send this packet to, or in the case of broadcasting who not to send it to. Use UNASSIGNED_PLAYER_ID to specify none
  `[in]` | broadcast | True to send this packet to all connected systems. If true, then playerId specifies who not to send the packet to.
Returns: False if we are not connected to the specified recipient. True otherwise Implemented in RakPeer, and RakServer.

virtual bool RakPeerInterface::Send | ( | const char * | data,
|  | const int | length,
|  | PacketPriority | priority,
|  | PacketReliability | reliability,
|  | char | orderingChannel,
|  | PlayerID | playerId,
|  | bool | broadcast
| ) | `[pure virtual]`

  | Sends a block of data to the specified system that you are connected to. This function only works while the connected Parameters:
  `[in]` | data | The block of data to send
  `[in]` | length | The size in bytes of the data to send
  `[in]` | priority | What priority level to send on. See PacketPriority.h
  `[in]` | reliability | How reliability to send this data. See PacketPriority.h
  `[in]` | orderingChannel | When using ordered or sequenced messages, what channel to order these on. Messages are only ordered relative to other messages on the same stream
  `[in]` | playerId | Who to send this packet to, or in the case of broadcasting who not to send it to. Use UNASSIGNED_PLAYER_ID to specify none
  `[in]` | broadcast | True to send this packet to all connected systems. If true, then playerId specifies who not to send the packet to.
Returns: False if we are not connected to the specified recipient. True otherwise Implemented in RakPeer, and RakServer.

virtual void RakPeerInterface::SendStaticData | ( | const PlayerID | target | ) | `[pure virtual]`

  | Sends your static data to the specified system. This is automatically done on connection. You should call this when you change your static data.To send the static data of another system (such as relaying their data) you should do this normally with Send) Parameters:
  `[in]` | target | Who to send your static data to. Specify UNASSIGNED_PLAYER_ID to broadcast to all
Implemented in RakPeer.

virtual void RakPeerInterface::SetCompileFrequencyTable | ( | bool | doCompile | ) | `[pure virtual]`

  | Enables or disables frequency table tracking. This is required to get a frequency table, which is used in GenerateCompressionLayer() This value persists between connect calls and defaults to false (no frequency tracking) Precondition: You can call this at any time - however you SHOULD only call it when disconnected. Otherwise you will only trackpart of the values sent over the network. Parameters:
  `[in]` | doCompile | True to enable tracking
Implemented in RakPeer.

virtual void RakPeerInterface::SetIncomingPassword | ( | const char * | passwordData,
|  | int | passwordDataLength
| ) | `[pure virtual]`

  | Sets the password incoming connections must match in the call to Connect (defaults to none). Pass 0 to passwordData to specify no password This is a way to set a low level password for all incoming connections. To selectively reject connections, implement your own scheme using CloseConnection() to remove unwanted connections Parameters:
  `[in]` | passwordData | A data block that incoming connections must match. This can be just a password, or can be a stream of data. Specify 0 for no password data
  `[in]` | passwordDataLength | The length in bytes of passwordData
Implemented in RakPeer.

virtual void RakPeerInterface::SetMaximumIncomingConnections | ( | unsigned short | numberAllowed | ) | `[pure virtual]`

  | Sets how many incoming connections are allowed. If this is less than the number of players currently connected, no more players will be allowed to connect. If this is greater than the maximum number of peers allowed, it will be reduced to the maximum number of peers allowed. Defaults to 0. Parameters:
  `[in]` | numberAllowed | Maximum number of incoming connections allowed.
Implemented in RakPeer.

virtual bool RakPeerInterface::SetMTUSize | ( | int | size | ) | `[pure virtual]`

| Set the MTU per datagram. It's important to set this correctly - otherwise packets will be needlessly split, decreasing performance and throughput. Maximum allowed size is MAXIMUM_MTU_SIZE. Too high of a value will cause packets not to arrive at worst and be fragmented at best. Too low of a value will split packets unnecessarily. Recommended size is 1500 sa MTUSize.h Precondition: Can only be called when not connected. Returns: false on failure (we are connected), else true Implemented in RakClient, RakPeer, and RakServer.

virtual void RakPeerInterface::SetOccasionalPing | ( | bool | doPing | ) | `[pure virtual]`

  | Ping the remote systems every so often, or not. This is off by default. Can be called anytime. Parameters:
  `[in]` | doPing | True to start occasional pings. False to stop them.
Implemented in RakPeer.

virtual void RakPeerInterface::SetOfflinePingResponse | ( | const char * | data,
|  | const unsigned int | length
| ) | `[pure virtual]`

  | Sets the data to send along with a LAN server discovery or offline ping reply. length should be under 400 bytes, as a security measure against flood attacks Parameters:
  `[in]` | data | a block of data to store, or 0 for none
  `[in]` | length | The length of data in bytes, or 0 for none
See also: Ping.cpp Implemented in RakPeer, and RakServer.

virtual void RakPeerInterface::SetRemoteStaticData | ( | const PlayerID | playerId,
|  | const char * | data,
|  | const int | length
| ) | `[pure virtual]`

  | All systems have a block of data associated with them, for user use. This block of data can be used to easily specify typical system data that you want to know on connection, such as the player's name. Parameters:
  `[in]` | playerId | Whose static data to change. Use your own playerId to change your own static data
  `[in]` | data | a block of data to store
  `[in]` | length | The length of data in bytes
Implemented in RakPeer.

virtual void RakPeerInterface::SetSplitMessageProgressInterval | ( | int | interval | ) | `[pure virtual]`

  | Controls how often to return ID_DOWNLOAD_PROGRESS for large message downloads. ID_DOWNLOAD_PROGRESS is returned to indicate a new partial message chunk, roughly the MTU size, has arrived As it can be slow or cumbersome to get this notification for every chunk, you can set the interval at which it is returned. Defaults to 0 (never return this notification) Parameters:
  `[in]` | interval | How many messages to use as an interval
Implemented in RakPeer.

virtual void RakPeerInterface::SetTimeoutTime | ( | RakNetTime | timeMS,
|  | const PlayerID | target
| ) | `[pure virtual]`

  | Set the time, in MS, to use before considering ourselves disconnected after not being able to deliver a reliable message. Default time is 10,000 or 10 seconds in release and 30,000 or 30 seconds in debug. Parameters:
  `[in]` | timeMS | Time, in MS
  `[in]` | target | Which system to do this for
Implemented in RakPeer, and RakServer.

virtual void RakPeerInterface::SetUnreliableTimeout | ( | RakNetTime | timeoutMS | ) | `[pure virtual]`

  | Set how long to wait before giving up on sending an unreliable message Useful if the network is clogged up. Set to 0 or less to never timeout. Defaults to 0. Parameters:
  `[in]` | timeoutMS | How many ms to wait before simply not sending an unreliable message.
Implemented in RakPeer.

The documentation for this class was generated from the following file:

- C:/RakNet 2.518/Include/RakPeerInterface.h